package tech.nevets.ubackup.client;

import java.io.File;
import java.io.FileInputStream;
import java.nio.file.Path;

public class Main {
    public static final Config SYS_CONF = new Config("./conf/system.json",
            "{\n  \"hostname\": \"server\", \n  \"backupDirectories\": [\n  ] \n  \"outputDirectory\": \"/opt/backups\" \n}"
            );
    private static final File OUTPUT_DIR = new File(SYS_CONF.getString("outputDirectory"));

    public static void main(String[] args) throws Exception {
        if (!OUTPUT_DIR.isDirectory()) {
            System.out.println("Output Directory not set to directory!");
            System.exit(1);
        }

        String[] backupDirs = SYS_CONF.getStringArray("backupDirectories");

        if (backupDirs.length == 1) {
            String filename = "TempArchiveName";
            Utils.archiveAndCompress(Path.of(backupDirs[0]), Path.of(SYS_CONF.getString("outputDirectory") + "/" + filename + ".tar.gz"));
        } else if (backupDirs.length > 1) {
            //TODO handle multiple backup directories
            for (String s : backupDirs) {
                Path p = Path.of(s);
            }
        }

        FTPSManager ftpsM = new FTPSManager();
        for (File f : OUTPUT_DIR.listFiles()) {
            System.out.println("Uploading " + f.getName() + "...");
            ftpsM.uploadBackup(new FileInputStream(f));
        }
        System.out.println("Finished uploading files");
        ftpsM.close();

    }
}
