package tech.nevets.ubackup.client;

import org.apache.commons.compress.archivers.ArchiveOutputStream;
import org.apache.commons.compress.archivers.ArchiveStreamFactory;
import org.apache.commons.compress.archivers.examples.Archiver;
import org.apache.commons.compress.compressors.CompressorOutputStream;
import org.apache.commons.compress.compressors.CompressorStreamFactory;

import java.io.BufferedOutputStream;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Utils {

    public static String getDateFormatted() {
        String pattern = "yyyy-MM-dd_HHmmss";
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(pattern);
        return simpleDateFormat.format(new Date());
    }

    public static void archive(Path directory, Path destination) throws Exception {
        new Archiver().create("tar", directory, destination);
    }

    public static void archiveAndCompress(Path directory, Path destination) throws Exception {
        try (OutputStream archive = Files.newOutputStream(destination);
             BufferedOutputStream archiveBuffer = new BufferedOutputStream(archive);
             CompressorOutputStream<?> compressor = new CompressorStreamFactory()
                     .createCompressorOutputStream("gz", archiveBuffer);
             ArchiveOutputStream<?> archiver = new ArchiveStreamFactory()
                     .createArchiveOutputStream("tar", compressor)) {
            new Archiver().create(archiver, directory);
        }
    }
}
